define({
	root: ({
		commonCore: {
			common: {
				add: "Add",
				edit: "Edit",
				save: "Save",
				next: "Next",
				cancel: "Cancel",
				back: "Back",
				apply: "Apply",
				close: "Close",
				open: "Open",
				start: "Start",
				loading: "Loading",
				disabledAdmin: "This feature has been disabled by the Administrator",
				width: "Width",
				height: "Height",
				create: "Create",
				yes: "Yes",
				no: "No",
				mystories: "My Stories"
			},
			inlineFieldEdit: {
				editMe: "Edit me!"
			},
			builderPanel: {
				panelHeader: "%TPL_NAME% Builder",
				buttonSaving: "Saving",
				buttonSaved: "Saved",
				buttonShare: "Share",
				buttonSettings: "Settings",
				buttonHelp: "Help",
				buttonPreview: "View story",
				tooltipFirstSave: "This isn't available until you save.",
				tooltipNotShared: "This isn't available until you share.",
				tooltipNotShared2: "Your story isn't shared, only you can access it.",
				noPendingChange: "No pending change",
				unSavedChangePlural: "Pending changes",
				closeWithPendingChange: "Are you sure to want to confirm this action? Your changes will be lost.",
				saveError: "Save failed, please try again",
				status1: "Story is shared but it has issues",
				status2: "Story isn't shared but it has issues",
				status3: "Story is public",
				status4: "Story is shared within your organization",
				status5: "Story is private",
				status6: "Story isn't saved yet",
				checking: "Checking",
				fix: "Fix"
			},
			saveError: {
				title: "Error saving the story",
				err1Div1: "The story can't be saved because you already have another item with the same name.",
				err1Div2: "Please modify the title of your story and then save it.",
				btnOk: "Edit the story title"
			},
			saveErrorSocial: {
				title: "Social media sharing update",
				panel1: "Your story’s appearance on social media has been improved, but your ArcGIS web application item title is not the same as your story title.",
				panel1tooltip: "By defining a title, summary and thumbnail image, your story will look like this:",
				panel2:	"Which title would you like to use on social media:",
				panel2q1: "Story title (recommended)",
				panel2q1tooltip: "By choosing this option, your item title will be modified to match your story title and further changes in the builder will be synchronized.",
				panel2q2: "Item title",
				panel3: "To further improve how your story looks on social media use ${MYSTORIES} to add a summary and a thumbnail image.",
				panel4: "Do not warn me again for this story"
			},
			share: {
				shareTitle: "Share your story",
				preview: "Preview",
				viewlive: "View story",
				btnPrivate: "Private",
				btnPrivateTooltip: "Only you can see the story",
				btnOrg: "Organization",
				btnOrgTooltip: "Only members of your organization can see the story",
				btnPublic: "Public",
				btnPublicTooltip: "Everyone can see the story",
				loadingMessage: "Checking your story for issues",
				viewToggle1: "Show story content",
				viewToggle2: "Close story content",
				socialize: "Socialize",
				statusPrivate: "Your story is private, only you can see it.",
				statusError: "There are issues in your story content that will be noticeable to your readers. You can identify and fix these issues below.",
				statusNoErrPrivate: "Share your story once you are ready!",
				mystoriesinvite: "Manage all your stories",
				notavailable1: "Sorry, sharing your story from the Builder is not supported since this application is not hosted in %PRODUCT%.",
				notavailable2: "Sorry, sharing your story from the Builder is not supported on this version of Portal for ArcGIS (requires 10.4 or later).",
				notavailable3: "You can share this story from %LINK%.",
				notavailable4: "My Stories",
				notavailable5: "its item page",
				notavailable6: "Sorry, this feature is not fully supported in development mode. Depending on your deployment scenario, this feature may be supported when deployed.",
				notavailable7: "Make sure to visit %MYCONTENT% to confirm the maps and layers used in your story are also shared.",
				notavailable8: "My Content",
				mystoriesinvite2: "To improve how your story looks on social networks use ${MYSTORIES} to add a summary and a thumbnail image."
			},
			settings: {
				header: "Settings",
				tabError: "Please check all tabs for errors"
			},
			settingsLayout: {
				title: "Layout",
				explain: "Which layout do you want to use?",
				explainInit: "You can change the layout anytime from the settings dialog.",
				viewExample: "View a live example"
			},
			settingsTheme: {
				title: "Theme"
			},
			settingsHeader: {
				title: "Header",
				logoEsriRadio: "Esri logo",
				logoNoneRadio: "No logo",
				logoOrgRadio: "Organization logo",
				logoCustomRadio: "My logo",
				logoCustomLabel: "Image:",
				logoCustomUploadHelp: "Logo image link must begin with HTTPS. Logos look best if they have a width:height ratio between 1:1 and 5:1. If a linked logo draws slowly, save a copy and upload it here.",
				logoCustomUploadTooltip: "Use an uploaded logo",
				logoCustomUploadButton: "Upload a logo",
				logoUploadSizeError: "GIF dimensions too large. Please resize to ${PIXEL-WIDTH} pixels wide.",
				logoCustomLinkHTTPSError: "Link must begin with HTTPS",
				logoCustomLinkTooltip: "Link to a logo",
				logoCustomLinkPlaceholder: "Image URL",
				logoCustomLinkPlaceholderHTTPS: "https://example.com/logo.jpg",
				logoUploadGenericError: "Logo can be a .bmp, .gif, .jpg, .jpeg, or .png file. Gifs must be less than 250px wide and 10Mb in size.",
				logoCustomTargetPlaceholder: "Web page to open when logo is clicked",
				logoSocialText: "Tagline:",
				logoLink: "Link:",
				lblSmallHeader: "Use compact header (no subtitle)"
			},
			header: {
				title: "Edit the title of your %TPL_NAME%",
				subtitle: "Edit the subtitle of your %TPL_NAME%"
			},
			sectionNavigation: {
				select: "Select a section...",
				section: "Section",
				thisSection: "This section",
				homeSection: "Home section",
				hiddenSection: "Hidden section"
			},
			bannerNotification: {
				learnMore: "Learn More",
				close: "Close",
				dontShowAgain: "Don't show this message again"
			},
			httpsTransitionMessage: {
				bannerMsg: "Important Message about Web Security and Story Maps",
				s1h1: "Esri is enhancing the security of Story Maps",
				s1p1: "Your Story Maps live on the web, and the web community is always working to establish and implement better security. HTTPS, which provides a secure connection for content transmitted over the internet, is emerging as the expected way to access web content. Most modern browsers now show warning messages when HTTP instead of HTTPS is used. Because of this emerging standard, we strongly recommend you use HTTPS links for authoring and sharing Story Maps, and only use HTTPS URLs when embedding web content or linking to images within a Story Map.",
				s1p2: "Practically speaking, this means a Story Map and all its content (including images, layers, embedded apps and websites) should be accessed using links that start with HTTPS rather than HTTP. This ensures the best experience for your readers because most web browsers will indicate that your stories are secure.",
				s2h1: "What do I need to do?",
				s2p1: "Esri is working to make this an easy transition for Story Map authors and readers. Tools are available now in Story Map builders and My Stories that help you find insecure content (HTTP) in your stories and provide recommendations for how to address it. Please check your stories for insecure content and update to HTTPS as soon as possible.",
				action1: "Close",
				action2: "Check my stories now",
				action3: "Learn more"
			},
			extendedSupportMessage: {
				bannerMsg: "Classic Esri Story Maps are in Extended Support",
				s1h1: "Important message about classic Esri Story Maps",
				s1p1: "Classic Esri Story Maps templates are in Extended Support. All customers are encouraged to use ArcGIS StoryMaps, Esri's current-generation storytelling tool.",
				s1p2: "The classic templates are no longer under active development and are not recommended for new projects. No further updates to their capabilities are planned. Stories you have created using the classic templates will continue to be available.",
				s1p3: "In December 2021, the classic templates will be removed from the default configurable apps gallery. One or more classic templates may be added to your organization’s custom configurable apps group if needed to support current workflows during your transition to using ArcGIS StoryMaps.",
				s1p4: "For more information, click the learn more link below.",
				action1: "Close",
				action2: "Learn more",
				action3: "Try ArcGIS StoryMaps"
			},
			matureSupportMessage: {
				bannerMsg: "Classic Esri Story Maps are in Mature Support",
				s1h1: "Important message about classic Esri Story Maps",
				s1p1: "Classic Esri Story Maps templates are in Mature Support. All customers are encouraged to use ArcGIS StoryMaps, Esri's current-generation storytelling tool.",
				s1p2: "The classic templates are no longer under active development and are not recommended for new projects. No further updates to their capabilities are planned. Stories you have created using the classic templates will continue to be available.",
				s1p3: "For more information, click the learn more link below.",
				action1: "Close",
				action2: "Learn more",
				action3: "Try ArcGIS StoryMaps"
			},
			embedBar: {
				share: "Share",
				fullScreen: "Full screen",
				exitFullScreen: "Exit full screen",
				enlarge: "Enlarge",
				newTab: "Open in a new tab",
				tagline: "A Story Map"
			},
			licenseChange2018: {
				noAccess: "Your account (%USER_NAME%) is not licensed to open a Story Map that is not public.  Please ask your organization administrator to assign you a user type that includes Story Maps or an add-on Essential Apps license."
			},
			storyTellerUserType: {
				notCreatorError: 'Your account (%USER_NAME%) is not licensed to use classic story map builders. Please ask your organization administrator to assign you a Creator user type.'
			}
		}
	}),
	"ar": 1,
	"bg": 1,
	"bs": 1,
	"ca": 1,
	"cs": 1,
	"da": 1,
	"de": 1,
	"el": 1,
	"es": 1,
	"et": 1,
	"fi": 1,
	"fr": 1,
	"he": 1,
	"hr": 1,
	"hu": 1,
	"id": 1,
	"it": 1,
	"ja": 1,
	"ko": 1,
	"lt": 1,
	"lv": 1,
	"nl": 1,
	"nb": 1,
	"pl": 1,
	"pt-br": 1,
	"pt-pt": 1,
	"ro": 1,
	"ru": 1,
	"sl": 1,
	"sk": 1,
	"sr": 1,
	"sv": 1,
	"th": 1,
	"tr": 1,
	"uk": 1,
	"vi": 1,
	"zh-cn": 1,
	"zh-hk": 1,
	"zh-tw": 1
});
