define({
	root: ({
		commonWebmap: {
			selector: {
				lblWebMap: "Map",
				lblLocation: "Location",
				lblContent: "Content",
				lblPopup: "Pop-up",
				lblControls: "Extras",
				lblOverview: "Overview Map",
				lblLegend: "Legend",
				lblGeocoder: "Address, Place, and Feature Finder",
				lblGeocoderNoFeatures: "Address and Place Finder",
				tooltipGeocoder: "Allow your readers to search for addresses, places, and/or features on your map. Search options can be configured on a web map's item page under Settings > Web Map > Application > Find Locations.",
				tooltipGeocoderNoEdit: "Allow your readers to search for addresses, places, and/or features on the map.",
				tooltipGeocoderNoFeatures: "Allow your readers to search for addresses and places on this map. To enable feature search, ask the owner of this map to configure it on the web map's item page under Settings > Web Map > Application > Find Locations.",
				linkGeocoder: "Configure map search",
				tooltipGeocoderLink: "Use this link to configure feature search and other search options. See the ArcGIS help topic &quot;Configure feature search&quot; for more information.",
				lblEsriGeocoder: "World Placefinder",
				placeholderGenericGeocoder: "Find address or place",
				loadingTitle: "Loading title",
				entry: "Entry",
				entries: "Entries",
				section: "Section",
				sections: "Sections",
				and: "and",
				action: "Action in section",
				actions: "Action in sections",
				originalWebmap: "Map used to publish the %TPL_NAME%",
				browseMaps: "Select a map",
				createMap: "Create a map",
				noResults: "No results found",
				loadingResults: "Loading...",
				current: "Current map",
				select: "Select or create a map",
				newMap: "Newly selected map",
				newCreatedMap: "Newly created map",
				webmapDefault: "Map default",
				customCfg: "Custom configuration",
				tooltipLocation: "Define the location that this map will display.",
				tooltipContent: "Define the visible layers.",
				tooltipPopup: "Choose a pop-up that will be opened when this map is displayed.",
				tooltipOverview: "Display a small overview map along with the main map.",
				tooltipLegend: "Display the map legend on the map, helpful when the map has many layers and symbols.",
				mapCfgInvite: "Use these controls to configure your map",
				lblLocationAlt: "Inherited from the first map",
				tooltipLocationAlt: "This map's location is synchronized to the first map in the series. To change this behavior for your series go to Settings > Map Options."
			},
			configure: {
				btnReset: "Reset",
				btnCancel: "Cancel",
				tocTitle: "Map content",
				tocExplain: "Select which layers will be shown.",
				tocNoData: "No layer can be configured.",
				tocSave: "Save map content",
				extentTitle: "Map location",
				extentExplain: "Pan and zoom the map to define how it will look for your readers.",
				extentSave: "Save Map location",
				popupTitle: "Map pop-up",
				popupExplain: "Click on a feature to open the pop-up you want to display.",
				popupSave: "Save the pop-up configuration",
				hintNavigation: "Map navigation is disabled."
			},
			editor: {
				loading: "Please wait while the map editor is loading",
				newTitle: "Create new map",
				editTitle: "Edit map",
				titleLbl: "Title",
				titlePh: "Map title...",
				folderLbl: "The map will be created in the same folder as the story.",
				creating: "Creating the map",
				saving: "Saving the map",
				success: "Map saved",
				successCreate: "Map created",
				cancelTitle: "Discard any unsaved changes?",
				close: "Close",
				save: "Save",
				confirm: "Yes, close map",
				deny: "No, keep working",
				errorDuplicate: "You already have a map with that title",
				errorCreate: "Unable to create map. Please try again.",
				errorSave: "Unable to save map. Please try again.",
				notavailable1: "Sorry, creating or editing a map is not supported in Firefox due to a technical limitation. You may want to build your story using a different web browser or use the following workaround.",
				notavailable2: "Sorry, creating or editing a map is not supported since the story map application is not hosted in %PRODUCT%. Please contact your ArcGIS administrator for more information.",
				notavailable3: "Sorry, creating or editing a map is not supported on this version of Portal for ArcGIS (requires 10.4 or later). Please contact your ArcGIS administrator for more information.",
				notavailable4: "You can create a map using %MV%, then come back here to add it to your story.",
				notavailable5: "You can edit the map using %MV%, then come back here and %apply% to see your changes.",
				notavailable6: "map viewer",
				notavailable7: "reload the map"
			}
		},
		configure: {
			mapdlg:{
				items:{
					organizationLabel: "My Organization",
					onlineLabel: "ArcGIS Online",
					contentLabel: "My Content",
					favoritesLabel: "My Favorites"
				},
				title: "Select a map",
				searchTitle: "Search",
				ok: "Ok",
				cancel: "Cancel",
				placeholder: "Enter search term or web map ID..."
			}
		}
	}),
	"ar": 1,
	"bg": 1,
	"bs": 1,
	"ca": 1,
	"cs": 1,
	"da": 1,
	"de": 1,
	"el": 1,
	"es": 1,
	"et": 1,
	"fi": 1,
	"fr": 1,
	"he": 1,
	"hr": 1,
	"hu": 1,
	"id": 1,
	"it": 1,
	"ja": 1,
	"ko": 1,
	"lt": 1,
	"lv": 1,
	"nl": 1,
	"nb": 1,
	"pl": 1,
	"pt-br": 1,
	"pt-pt": 1,
	"ro": 1,
	"ru": 1,
	"sl": 1,
	"sk": 1,
	"sr": 1,
	"sv": 1,
	"th": 1,
	"tr": 1,
	"uk": 1,
	"vi": 1,
	"zh-cn": 1,
	"zh-hk": 1,
	"zh-tw": 1
});
