define({
	root: ({
		viewer: {
			common: {
				close: "Close",
				focusMainstage: "Send keyboard focus to media",
				expandImage: "Expand image"
			},
			a11y: {
				skipToContent: "Skip to narrative",
				headerAria: "Story header",
				panelAria: "Story narrative",
				mainStageAria: "Current story section media",
				logoLinkAria: "Logo link",
				toTop: "Go to beginning of narrative",
				focusContent: "Return to narrative",
				navAria: "Story sections",
				navPreviousAria: "Previous section",
				navNextAria: "Next section",
				toSectionAria: "Go to section %SECTION_NUMBER%: %SECTION_TITLE%",
				toNextGroupAria: "Next group of sections (%SECTION_RANGE%)",
				toPrevGroupAria: "Previous group of sections (%SECTION_RANGE%)",
				loadingAria: "Story content is loading"
			},
			loading: {
				step1: "Loading story",
				step2: "Loading data",
				step3: "Initializing",
				loadBuilder: "Switching to builder",
				long: "Map Journal is initializing",
				long2: "Thanks for waiting",
				failButton: "Reload the story"
			},
			signin: {
				title: "Authentication is required",
				explainViewer: "Please sign in with an account on %PORTAL_LINK% to access the story.",
				explainBuilder: "Please sign in with an account on %PORTAL_LINK% to configure the story."
			},
			errors: {
				boxTitle: "An error has occurred",
				invalidConfig: "Invalid configuration",
				invalidConfigNoApp: "Web Mapping Application identifier not specified in index.html.",
				invalidConfigNoAppDev: "No Web Mapping Application identifier is specified in URL parameters (?appid=). In development mode, the appid configuration in index.html is ignored.",
				unspecifiedConfigOwner: "Authorized owner hasn't been configured.",
				invalidConfigOwner: "Story owner is not authorized.",
				createMap: "Unable to create map",
				invalidApp: "The %TPL_NAME% does not exist or is inaccessible.",
				appLoadingFail: "Something went wrong, the %TPL_NAME% did not load correctly.",
				notConfiguredDesktop: "The story is not configured yet.",
				notConfiguredMobile: "The %TPL_NAME% builder is not supported at this display size. If possible, resize your browser to access the builder or please build your story on a device with a larger screen.",
				notConfiguredMobile2: "Please rotate your device to landscape orientation to use the %TPL_NAME% builder.",
				notAuthorized: "You are not authorized to access this story",
				notAuthorizedBuilder: "You are not authorized to use %TPL_NAME% builder.",
				noBuilderIE: "The builder is not supported on Internet Explorer before version %VERSION%. %UPGRADE%",
				noViewerIE: "This story is not supported in Internet Explorer before version %VERSION%. %UPGRADE%",
				noViewerIE2: "You are attempting to view this story using an older, unsupported browser. There may be features that do not work or other unexpected issues. We suggest you upgrade to Internet Explorer 11 or use another browser, such as Chrome.",
				noViewerIE3: "In late 2017, this story will no longer load on this browser. At that time, you must use a supported browser to view this story.",
				upgradeBrowser: "<a href='http://browsehappy.com/' target='_blank'>Please update your browser</a>.",
				mapLoadingFail: "Something went wrong, the map did not load correctly.",
				signOut: "Sign Out",
				print0: "Sorry, this story cannot be printed.",
				print1: "To print this story, please use the print button located in the share dialog.",
				print2: "Sorry, a printable version of the story is typically accessible through the share dialog, but this dialog has been disabled by the author.",
				attention: "Attention!",
				nonOwnerOrgUrl: "The %TPL_NAME% you are trying to access does not originate from the URL you provided.",
				nonOwnerOrgProceedToGeneric: "Proceed to %HREF%",
				advanced: "Advanced"
			},
			mobileView: {
				tapForDetails: "Tap for details",
				clickForDetails: "Learn more",
				swipeToExplore: "Swipe to explore",
				tapForMap: "Tap to go back",
				clickForMap: "BACK"
			},
			floatLayout: {
				scroll: "Scroll"
			},
			sideLayout: {
				scroll: "Scroll down for more!"
			},
			mainStage: {
				back: "Back",
				errorDeleted: "This link is not active (section has been deleted)",
				errorNotPublished: "This link is not active (section is not published)"
			},
			headerFromCommon: {
				storymapsText: "A Story Map",
				builderButton: "Edit",
				facebookTooltip: "Share on Facebook",
				twitterTooltip: "Share on Twitter",
				bitlyTooltip: "Share or print",
				templateTitle: "Set template title",
				templateSubtitle: "Set template subtitle",
				share: "Share",
				checking: "Checking your story content",
				fix: "Fix issues in your story",
				noerrors: "No issues detected",
				tooltipAutoplayDisabled: "This isn't available in autoplay mode",
				notshared: "Story not shared"
			},
			mapFromCommon: {
				overview: "Overview Map",
				legend: "Legend",
				home: "Zoom Home"
			},
			shareFromCommon: {
				copy: "Copy",
				copied: "Copied",
				open: "Open",
				embed: "Embed in web page",
				embedExplain: "Use the following HTML code to embed the journal in a web page.",
				size: "Size (width/height):",
				autoplayLabel: "Autoplay mode",
				autoplayExplain1: "Autoplay mode will advance through your story at a regular interval. This is ideal on a kiosk or public display monitor, but be aware that in other situations it may make the story harder to read. This feature isn't supported on small displays.",
				autoplayExplain2: "When this mode is active there are controls to play/pause the story and adjust the navigation speed.",
				linksupdated: "Links updated!",
				print: "Print",
				printInstruction1: "Please wait for the entire story to load before printing",
				printInstruction1a: "If this page loads slowly or some media doesn't appear, try printing a smaller range of sections.",
				printInstruction1b: "For best results, you may need to enable printing of background elements in your browser's print settings.",
				printInstruction2: "This page cannot be shared with others, instead share the ${link}",
				link: "link to the story",
				optionsHeader: "Options",
				printOptPageBreak: "Begin each section on a new page",
				makeTextBlack: "Make all text black",
				showLinks: "Show link URLs",
				madeWith: "This story was made with ${JOURNAL_LINK_TEXT}.",
				journalLinkText: "Esri's Story Map Journal",
				readItOnline: "Read the interactive version on the web at ${link}.",
				printMSWarning: "link available only in online story",
				printVideoWarning: "This video can be viewed in the online version of this story map",
				printRangeHeader: "Print part of this story",
				sectionLabel: "Sections:",
				apply: "Apply",
				resetRange: "Reset to whole story"


			}
    }
  }),
	"ar": 1,
	"bg": 1,
	"bs": 1,
	"ca": 1,
	"cs": 1,
	"da": 1,
	"de": 1,
	"el": 1,
	"es": 1,
	"et": 1,
	"fi": 1,
	"fr": 1,
	"he": 1,
	"hr": 1,
	"hu": 1,
	"id": 1,
	"it": 1,
	"ja": 1,
	"ko": 1,
	"lt": 1,
	"lv": 1,
	"nl": 1,
	"nb": 1,
	"pl": 1,
	"pt-br": 1,
	"pt-pt": 1,
	"ro": 1,
	"ru": 1,
	"sl": 1,
	"sk": 1,
	"sr": 1,
	"sv": 1,
	"th": 1,
	"tr": 1,
	"uk": 1,
	"vi": 1,
	"zh-cn": 1,
	"zh-hk": 1,
	"zh-tw": 1
});
